/**
 * \file protocol_avr911.c
 *
 * \brief RCUZ
 *
 * ̧ق8MHzRCUZpٰ݂񋟂܂B
 *
 * 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#include "RC_Calib.h"
#include "TPI_driver.h"

/* RCUZpٰ */
uint8_t RC_Calibrate (void)
{
	/* I/O݌`Ԑݒ */
	uint8_t Temp_DDRD = DDRD;
	uint8_t Temp_PORTD = PORTD;
	uint8_t osccal_value = 0, temp;

	/* USART1֎~ */
	UCSR1B &= ~((1<<TXEN1)|(1<<RXEN1));

	/* ZԊm̂߂PD2PD3͂ƂČ`Ԑݒ */
	DDRD &= ~((1<<TPI_DATA_TX)|(1<<TPI_DATA_RX));

	/* PD2PD3ٱ߂ */
	PORTD |= (1<<TPI_DATA_TX)|(1<<TPI_DATA_RX);

	/* Zۯ񋟂邽߂PD4o͂ƂČ`Ԑݒ */
	DDRD |= (1<<TPI_CLK);

	/* PD2PD3ٱ߂ */
	PORTD |= ((1<<PORTD2)|(1<<PORTD3));

	/* 32kHzM𐶐悤/1`Ԑݒ */
	OCR1A = 0xAD;
	TCCR1A = (1<<COM1B0);
	TCCR1B = (1<<WGM12)|(1<<CS10);

	while((PIND & (1<<PIND2))!=0);

	TCCR1B = 0x00;
	TCCR1A = 0x00;

	PORTD |= (1<<PORTD4);
	_delay_ms(1);

	for(uint8_t i=0; i<8 ;i++)
	{
		PORTD &= ~(1<<PORTD4);
		_delay_us(100);
		PORTD |= (1<<PORTD4);
		temp = (PIND<<5) & 0x80;
		osccal_value |= (temp>>i);
	}

	/* USART1 */
	UCSR1B |= ((1<<TXEN1)|(1<<RXEN1));

	DDRD = Temp_DDRD;
	PORTD = Temp_PORTD;

	return(osccal_value);
}
